:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3210,_3204/_3206,_3214):-(retract(dynamicVersion(_3210,_3204/_3206,_3228))->true;true),asserta(dynamicVersion(_3210,_3204/_3206,_3214)).
prim_assertFact('Dynamic.Dynamic'(_3322),'Prelude.()'):-retract(dynamicTime(_3332)),_3346 is _3332+1,assertz(dynamicTime(_3346)),_3322=..[_3360,_3366,_3372,_3378|_3380],_3408=..[_3360,_3346,0|_3380],assertz(user:_3408),logDynamicEvent(_3366,assertz,_3408).
prim_retractFact('Dynamic.Dynamic'(_3510),_3516):-_3510=..[_3520,_3526,_3532,_3538|_3540],_3568=..[_3520,_3556,_3562|_3540],reloadNewestDynamicVersionOf(_3520),retract(dynamicTime(_3578)),_3592 is _3578+1,assertz(dynamicTime(_3592)),call(user:_3568),isInTimeInterval(_3578,_3556,_3562),!,_3642=..[_3520,_3556,_3578|_3540],retract(user:_3568),!,logDynamicEvent(_3526,retract,_3568),assertz(user:_3642),_3516='Prelude.True'.
prim_retractFact(_3808,'Prelude.False').
prim_getDynamicKnowledge(_3844):-reloadNewestDynamicVersions,dynamicTime(_3848),term2partcall('Dynamic.isKnownAtTime'(_3848),1,_3844),(compileWithSharing(function)->makeShare(_3844,_3870);_3870=_3844).
prim_isKnownAtTime(_3948,'Dynamic.Dynamic'(_3944),'Prelude.True'):-_3944=..[_3956,_3962,_3968,_3974|_3976],_4004=..[_3956,_3992,_3998|_3976],call(user:_4004),isInTimeInterval(_3948,_3992,_3998).
isInTimeInterval(_4096,_4098,_4100):-_4096>=_4098,(_4100=0->true;_4096=<_4100).
logDynamicEvent('Dynamic.Temporary',_4192,_4194):-!.
logDynamicEvent('Dynamic.Persistent',_4250,_4252):-_4252=..[_4256,_4262,_4268|_4270],_4298=..[_4256,0,0|_4270],_4316=..[_4250,_4298],user:dynamicPredInfo(_4256/_4324,_4330),logDynamic(_4316,_4330).
logDynamic(_4420,_4422):-dir2tmplockfile(_4422,_4428),lockWithFileIfNotInTransaction(_4428),executeWithFinalize((dir2logfile(_4422,_4438),open(_4438,append,_4446),writeq(_4446,_4420),put_code(_4446,46),nl(_4446),flush_output(_4446),close(_4446),addChangePid(_4422)),unlockWithFileIfNotInTransaction(_4428)).
executeWithFinalize(_4584,_4586):-on_exception(_4594,_4584,(call(_4586),printError(_4594),!,fail)),!,call(_4586).
executeWithFinalize(_4682,_4684):-call(_4684),!,fail.
prim_startTransaction(_4746):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4808,initTransaction(_4746),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4808),fail)),!.
initTransaction(_4890):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4894)),_4890 is _4894+1,assertz(dynamicTime(_4890)),logAllDynamicPreds(startTransaction(_4890)).
prim_commitTransaction(_4994,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4994)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5078):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5086),map1partialM(prim_dynamic:addChangePid(0),_5086),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5192):-findall(_5196,isDynamicDir(_5196),_5204),sort(_5204,_5192).
isDynamicDir(_5254):-user:dynamicPredInfo(_5258,_5254),\+_5254=''.
logAllDynamicPreds(_5320):-getDynamicDirs(_5324),map1partialM(prim_dynamic:logDynamic(_5320),_5324).
initializeDynamic:-user:dynamicPredInfo(_5384/_5386,_5392),initializeDynamic(_5392,_5384/_5386),fail.
initializeDynamic.
initializeDynamic('',_5462/_5464):-!,retractAllFacts(_5462/_5464).
initializeDynamic(_5538,_5532/_5534):-existsDirectory(_5538),!,checkDynSpec(_5538,_5532/_5534),setDynamicVersion(_5538,_5532/_5534,0),!.
initializeDynamic(_5640,_5642):-existsFile(_5640),!,appendAtom('ERROR: Directory "',_5640,_5654),appendAtom(_5654,'" for dynamic entries cannot be created!',_5662),writeErr(_5662),nlErr,!,fail.
initializeDynamic(_5760,_5754/_5756):-upDirectory(_5760,_5768),(existsDirectory(_5768)->createDynamicDir(_5760,_5754/_5756),setDynamicVersion(_5760,_5754/_5756,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5760),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5946,_5948):-atom_codes(_5946,_5954),append(_5964,[47|_5960],_5954),\+member(47,_5960),!,atom_codes(_5948,_5964).
upDirectory(_6054,'.').
checkDynSpec(_6096,_6090/_6092):-dir2specfile(_6096,_6104),existsFile(_6104),readPrologTermFile(_6104,_6114),dynamicSpec(_6090/_6092,_6114),!.
checkDynSpec(_6196,_6198):-appendAtom('ERROR: Directory "',_6196,_6206),appendAtom(_6206,'" contains no matching dynamic entries!',_6214),writeErr(_6214),nlErr,!,fail.
replayLogFile(_6300,_6294/_6296):-dir2tmplockfile(_6300,_6308),lockWithFileIfNotInTransaction(_6308),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6300,_6294/_6296),unlockWithFileIfNotInTransaction(_6308)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6416,_6410/_6412):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6416),writeErr('\'...'),nlErr;true),getRunTime(_6470),ensurePakcsVersion(_6416),dir2dbfile(_6416,_6480),dir2pofile(_6416,_6486),consultPrologorPOFile(_6480,_6486),dir2logfile(_6416,_6498),open(_6498,read,_6506),(atEndOfStream(_6506)->close(_6506);assert(replayStatus(unchanged)),repeat,on_exception(_6536,readAndReplay(_6506),((printError(_6536)->true;true),writeErr('ERROR during reading of '),writeErr(_6498),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6506),retract(replayStatus(_6600)),writeNewDatabaseIfChanged(_6410/_6412,_6416,_6600)),updateDynFactsIfNecessary(_6416,_6410/_6412),readDynamicVersion(_6416,_6672),setDynamicVersion(_6416,_6410/_6412,_6672),writeChangePids(_6416,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6706),_6716 is _6706-_6470,writeErr(_6716),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6898):-readPAKCSVersion(_6898,_6904),_6904=pakcsVersion(_6908,_6910),prologMajor(_6920),\+_6920=_6910,dir2pofile(_6898,_6936),(existsFile(_6936)->deleteFile(_6936);true),writePAKCSVersion(_6898),!.
ensurePakcsVersion(_7040).
isCurrentPakcsVersion(_7066):-readPAKCSVersion(_7066,_7072),compilerVersion(_7076),!,(_7072=compilerVersion(_7076)->writePAKCSVersion(_7066);_7072=pakcsVersion(_7076,_7102)).
readPAKCSVersion(_7170,_7172):-dir2pakcsversionfile(_7170,_7178),existsFile(_7178),readPrologTermFile(_7178,_7172).
writePAKCSVersion(_7246):-dir2pakcsversionfile(_7246,_7252),compilerVersion(_7256),prologMajor(_7260),writePrologTermFile(_7252,pakcsVersion(_7256,_7260)).
updateDynFactsIfNecessary(_7328,_7330):-isCurrentPakcsVersion(_7328),!.
updateDynFactsIfNecessary(_7392,_7386/_7388):-compilerVersion(_7398),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7392),writeErr('\' to compiler version '),writeErr(_7398),writeErr(...),nlErr;true),updateDynFacts(_7386/_7388),writeNewDatabaseIfChanged(_7386/_7388,_7392,changed),writePAKCSVersion(_7392).
updateDynFactsIfNecessary(_7564,_7566).
updateDynFacts(_7600/_7602):-functor(_7610,_7600,_7602),functor(_7618,_7600,_7602),retract(user:_7610),arg(1,_7610,_7640),arg(1,_7618,_7640),arg(2,_7610,_7656),arg(2,_7618,_7656),translateDynFactArgs(3,_7602,_7610,_7618),asserta(user:_7618),fail.
updateDynFacts(_7776).
translateDynFactArgs(_7802,_7804,_7806,_7808):-_7802>_7804,!.
translateDynFactArgs(_7882,_7884,_7886,_7888):-arg(_7882,_7886,_7896),translateDynFactArg(_7896,_7902),arg(_7882,_7888,_7902),_7920 is _7882+1,translateDynFactArgs(_7920,_7884,_7886,_7888).
translateDynFactArg(_8018,_8018):-var(_8018),!.
translateDynFactArg(_8076,_8076):-number(_8076),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8614,_8616):-atomic(_8614),atom_codes(_8614,[40|_8626]),!,appendAtom('Prelude.',_8614,_8616).
translateDynFactArg(_8704,_8706):-atom(_8704),atom_codes(_8704,[39|_8716]),!,(_8716=[_8726]->char_int(_8706,_8726);_8716=[78,85,76]->char_int(_8706,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8868,_8868):-atomic(_8868),!.
translateDynFactArg(_8926,_8928):-functor(_8926,_8934,_8936),translateDynFactArg(_8934,_8942),functor(_8928,_8942,_8936),translateDynFactArgs(1,_8936,_8926,_8928).
writeNewDatabaseIfChanged(_9024/_9026,_9032,changed):-!,dir2dbfile(_9032,_9040),dir2pofile(_9032,_9046),dir2logfile(_9032,_9052),appendAtom(_9040,'.bak',_9060),tell(_9060),writeq((:-dynamic _9024/_9026)),put_code(46),nl,listing(user:_9024/_9026),told,try_save_predicates(_9024/_9026,_9046),renameFile(_9060,_9040),appendAtom(_9052,'.bak',_9128),renameFile(_9052,_9128),appendAtom('touch ',_9052,_9142),shellCmd(_9142),readDynamicVersion(_9032,_9152),_9162 is _9152+1,writeDynamicVersion(_9032,_9162),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9372/_9374,_9380,_9382):-dir2logfile(_9380,_9388),appendAtom(_9388,'.bak',_9396),renameFile(_9388,_9396),appendAtom('touch ',_9388,_9410),shellCmd(_9410).
readAndReplay(_9492):-atEndOfStream(_9492),!.
readAndReplay(_9540):-read(_9540,_9546),replayEvent(_9540,_9546).
replayEvent(_9596,end_of_file):-!.
replayEvent(_9648,startTransaction(_9644)):-readAndReplayTransaction(_9648,_9644,[]),!,fail.
replayEvent(_9716,_9718):-retract(replayStatus(_9722)),assert(replayStatus(changed)),call(user:_9718),!,fail.
readAndReplayTransaction(_9814,_9816,_9818):-atEndOfStream(_9814),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9816),nlErr;true).
readAndReplayTransaction(_9926,_9928,_9930):-read(_9926,_9936),(_9936=commitTransaction(_9928)->callRevList(_9930);_9936=abortTransaction->true;readAndReplayTransaction(_9926,_9928,[_9936|_9930])),!.
callRevList([]).
callRevList([_10086|_10088]):-callRevList(_10088),retract(replayStatus(_10100)),assert(replayStatus(changed)),call(user:_10086).
startTransaction(_10178).
commitTransaction(_10204).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10242),map1M(prim_dynamic:lockDynamicDir,_10242).
lockDynamicDir(_10288):-dir2lockfile(_10288,_10294),lockWithFile(_10294).
lockWithFileIfNotInTransaction(_10342):-insideTransaction->true;lockWithFile(_10342).
lockWithFile(_10396):-appendAtom('lockfile-create --lock-name ',_10396,_10404),(existsFile(_10396),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10396),writeErr('\'...'),nlErr;true),shellCmd(_10404),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10522),map1M(prim_dynamic:unlockDynamicDir,_10522).
unlockDynamicDir(_10568):-dir2lockfile(_10568,_10574),unlockWithFile(_10574).
unlockWithFileIfNotInTransaction(_10622):-insideTransaction->true;unlockWithFile(_10622).
unlockWithFile(_10676):-existsFile(_10676),!,appendAtom('lockfile-remove --lock-name ',_10676,_10688),shellCmd(_10688).
unlockWithFile(_10748).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10774/_10776,_10782),dynamicVersion(_10782,_10774/_10776,_10802),reloadNewestDynamicVersion(_10782,_10774/_10776,_10802),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10874):-dynamicVersion(_10884,_10874/_10880,_10888),!,reloadNewestDynamicVersion(_10884,_10874/_10880,_10888).
reloadNewestDynamicVersionOf(_10952).
reloadNewestDynamicVersion(_10984,_10978/_10980,0):-!,retractAllFacts(_10978/_10980),replayLogFile(_10984,_10978/_10980),!.
reloadNewestDynamicVersion(_11088,_11082/_11084,_11092):-readDynamicVersion(_11088,_11098),\+_11092=_11098,!,retractAllFacts(_11082/_11084),replayLogFile(_11088,_11082/_11084),!.
reloadNewestDynamicVersion(_11214,_11216,_11218):-readChangePids(_11214,_11224),currentPID(_11228),(_11224=[];_11224=[_11228]),!.
reloadNewestDynamicVersion(_11330,_11324/_11326,_11334):-retractAllFacts(_11324/_11326),replayLogFile(_11330,_11324/_11326).
createDynamicDir(_11422,_11416/_11418):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11422),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11422,_11480),shellCmd(_11480),dir2logfile(_11422,_11490),appendAtom('touch ',_11490,_11498),shellCmd(_11498),dir2dbfile(_11422,_11508),appendAtom('touch ',_11508,_11516),shellCmd(_11516),dir2specfile(_11422,_11526),dynamicSpec(_11416/_11418,_11538),writePrologTermFile(_11526,_11538),writePAKCSVersion(_11422).
readPrologTermFile(_11666,_11668):-open(_11666,read,_11676),read(_11676,_11668),close(_11676).
writePrologTermFile(_11744,_11746):-open(_11744,write,_11754),writeq(_11754,_11746),put_code(_11754,46),nl(_11754),flush_output(_11754),close(_11754).
readDynamicVersion(_11854,_11856):-dir2versionfile(_11854,_11862),existsFile(_11862),!,on_exception(_11882,readPrologTermFile(_11862,_11856),_11856=0).
readDynamicVersion(_11950,1).
writeDynamicVersion(_11986,_11988):-dir2versionfile(_11986,_11994),writePrologTermFile(_11994,_11988).
readChangePids(_12052,_12054):-dir2changepidsfile(_12052,_12060),existsFile(_12060),!,on_exception(_12086,readPrologTermFile(_12060,_12054),_12054=[0]).
readChangePids(_12154,[]).
writeChangePids(_12190,_12192):-dir2changepidsfile(_12190,_12198),writePrologTermFile(_12198,_12192).
addChangePid(_12256):-currentPID(_12260),addChangePid(_12260,_12256).
addChangePid(_12310,_12312):-readChangePids(_12312,_12318),(member(_12310,_12318)->true;writeChangePids(_12312,[_12310|_12318])),!.
dynamicSpec(_12406/_12408,dynamicPredicate(_12406,_12408)).
retractDeadDynamicFacts(_12454/_12456):-length(_12464,_12456),_12476=..[_12454|_12464],_12464=[_12482,_12488|_12490],dynamicTime(_12500),call(user:_12476),_12488>0,_12500>_12488,retract(user:_12476),fail.
retractDeadDynamicFacts(_12618).
dir2logfile(_12644,_12646):-appendAtom(_12644,'/eventlog',_12646).
dir2lockfile(_12700,_12702):-appendAtom(_12700,'/LOCK',_12702).
dir2tmplockfile(_12756,_12758):-appendAtom(_12756,'/LOCK',_12758).
dir2dbfile(_12812,_12814):-appendAtom(_12812,'/database.pl',_12814).
dir2pofile(_12868,_12870):-appendAtom(_12868,'/dbpred.po',_12870).
dir2specfile(_12924,_12926):-appendAtom(_12924,'/spec',_12926).
dir2pakcsversionfile(_12980,_12982):-appendAtom(_12980,'/pakcsversion',_12982).
dir2versionfile(_13036,_13038):-appendAtom(_13036,'/version',_13038).
dir2changepidsfile(_13092,_13094):-appendAtom(_13092,'/changepids',_13094).
