:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3180):-(getEnv('PAKCS_LOCALHOST',_3186)->true;_3186=no),(_3186=yes->asserta(only_localhost(yes)),_3180=yes;asserta(only_localhost(no)),_3180=no),retract((only_localhost(_3266):-_3270,_3272)),!.
tracePorts(unknown).
ifTracePort(_3364):-tracePorts(_3368),(_3368=unknown->retract(tracePorts(_3378)),(getEnv('PAKCS_TRACEPORTS',_3388)->true;_3388=no),(_3388=yes->asserta(tracePorts(yes)),_3364;asserta(tracePorts(no)));_3368=yes->_3364;true).
prim_openPort(_3532,_3534,_3536):-nonvar(_3532),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3622,_3624,_3626):-nonvar(_3624),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3718),_3718,'Prelude.True').
prim_openPortOnSocket(_3768,_3770,_3772):-(retract(mySocket('Ports.internalPort'(_3776,_3778,_3780,_3782)))->_3800 is _3780+1,asserta(mySocket('Ports.internalPort'(_3776,_3778,_3800,_3782))),(_3768=_3778,_3770=_3800->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3768),on_exception(_3906,listenOnNewSocket(_3768,_3888,_3782),(write('ERROR: openPortOnSocket "'),write(_3768),write('":'),nl,printError(_3906),!,fail)),atom2String(_3888,_3776),(var(_3770)->_3770=0;true),asserta(mySocket('Ports.internalPort'(_3776,_3768,_3770,_3782)))),mySocket(_4030),_4030='Ports.internalPort'(_4034,_4036,_4038,_4040),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_4038),writeErr(' at socket '),writeErr(_4036),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_4034,_4086),writeErr(_4086)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4030),_3772);_3772='Ports.basicServerLoop'(_4030)).
trySetSocketNumber(_4266):-var(_4266),getEnv('PAKCS_SOCKET',_4276),atom_codes(_4276,_4282),number_codes(_4266,_4282),!.
trySetSocketNumber(_4350).
prim_basicServerLoop(_4654,_4656,_4658,_4660):-freeze(_4658,blocked_prim_basicServerLoop(_4654,_4656,_4658,_4660)).
blocked_prim_basicServerLoop(_4722,_4724,_4726,_4728):-readPort(_4722,_4734,-1),_4724=[_4734|_4742],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4722),_4742);_4742='Ports.basicServerLoop'(_4722)),_4726=_4728.
prim_timeoutOnStream(_5150,_5152,_5154,_5156,_5158):-freeze(_5156,blocked_prim_timeoutOnStream(_5150,_5152,_5154,_5156,_5158)).
blocked_prim_timeoutOnStream(_5228,_5230,_5232,_5234,_5236):-user:derefRoot(_5228,_5242),prim_timeoutOnStream_exec(_5242,_5230,_5232,_5234,_5236).
prim_timeoutOnStream_exec(_5336,_5338,'Prelude.Nothing',_5342,_5344):-var(_5338),!,_5342=_5344.
prim_timeoutOnStream_exec(_5440,share(_5436),_5444,_5446,_5448):-!,get_mutable(_5452,_5436),(_5452='$eval'(_5458)->_5444=_5458,_5446=_5448;prim_timeoutOnStream_exec(_5440,_5452,_5496,_5446,_5448),(_5496='Prelude.Nothing'->_5444=_5496;(compileWithSharing(variable)->user:propagateShare(_5496,_5444);_5496=_5444),update_mutable('$eval'(_5444),_5436))).
prim_timeoutOnStream_exec(_5672,[],'Prelude.Just'([]),_5678,_5680):-!,_5678=_5680.
prim_timeoutOnStream_exec(_5778,[_5762|_5764],'Prelude.Just'([_5762|_5764]),_5784,_5786):-!,_5784=_5786.
prim_timeoutOnStream_exec(_5872,'Ports.basicServerLoop'(_5868),_5876,_5878,_5880):-(readPort(_5868,_5886,_5872)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5868),_5902);_5902='Ports.basicServerLoop'(_5868)),_5876='Prelude.Just'([_5886|_5902]);_5876='Prelude.Nothing'),_5878=_5880.
send_extvar_binding(_6318,_6320,_6322,_6324):-freeze(_6320,blocked_send_extvar_binding(_6318,_6320,_6322,_6324)).
blocked_send_extvar_binding(_6386,_6388,_6390,_6392):-evalToken(_6396),user:normalizeAndCheck(_6388,_6402,_6396,_6406),user:waitUntilGround(_6402,_6406,_6420),eval_send_extvar_binding(_6386,_6402,_6390,_6420,_6392).
eval_send_extvar_binding(_6822,_6824,_6826,_6828,_6830):-freeze(_6828,blocked_eval_send_extvar_binding(_6822,_6824,_6826,_6828,_6830)).
blocked_eval_send_extvar_binding(nostream,_6902,_6904,_6906,_6908):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6904),writeErr(': '),writeErr(_6902),nlErr,!.
blocked_eval_send_extvar_binding(_7024,_7026,_7028,_7030,_7032):-show4sending(_7026,_7038,_7040),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_7028),writeErr(': '),writeChars(user_error,_7038),nlErr)),number_codes(_7028,_7092),putChars(_7024,[86|_7092]),put_code(_7024,10),writeChars(_7024,_7038),put_code(_7024,10),flush_output(_7024),!,_7032=done.
readPort('Ports.internalPort'(_7256,_7258,_7260,_7262),_7268,_7270):-var(_7262),!,string2Atom(_7256,_7280),writeErr('ERROR: readPort: Port '),writeErr(_7258),writeErr(/),writeErr(_7260),writeErr(@),writeErr(_7280),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7422,_7424,_7426,_7428),_7434,_7436):-on_exception(_7450,readFromSocket(_7426,_7428,_7434,_7436),(printError(_7450)->_7434=[];_7434=[])),!.
checkIncomingPortStreams(_7542,_7544,_7546):-retract(incomingPortStreams(_7542,[message(_7544,_7546)|_7558])),asserta(incomingPortStreams(_7542,_7558)),!.
checkIncomingPortStreams(_7644,_7646,_7648):-retract(incomingPortStreams(_7644,[ping(_7652,_7654)|_7660])),asserta(incomingPortStreams(_7644,_7660)),answerPingOnStream(_7652,_7654),checkIncomingPortStreams(_7644,_7646,_7648),!.
answerPingOnStream(_7772,_7774):-write(_7774,ok),put_code(_7774,10),flush_output(_7774),closeSocketStream(_7772,_7774),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7880,_7882,_7884,_7886):-checkIncomingPortStreams(_7880,_7892,_7894),!,readStreamLine(_7892,_7900),(parse_received_message(_7892,_7894,_7900,_7884)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7900),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7900),nlErr,readFromSocket(_7880,_7882,_7884,_7886)),!.
readFromSocket(_8072,_8074,_8076,_8078):-waitForSocketClientStream(_8074,_8078,_8086,_8088,_8090),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8086),nlErr)),(readPortMessage(_8072,_8088,_8090,_8124)->(parse_received_message(_8088,_8090,_8124,_8076)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8124),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8124),nlErr,readFromSocket(_8072,_8074,_8076,_8078));readFromSocket(_8072,_8074,_8076,_8078)),!.
readFromSocket(_8312,_8314,_8316,_8318):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8400,_8402,_8404,_8406):-readStreamLine(_8402,_8412),_8412=[_8416|_8418],checkMessageHeader(_8416,_8402,_8404,_8434),number_codes(_8438,_8418),!,(_8438=_8400->readPortMessageBody(_8434,_8406);(retract(incomingPortStreams(_8438,_8464))->append(_8464,[_8434],_8482);_8482=[_8434]),asserta(incomingPortStreams(_8438,_8482)),!,fail).
checkMessageHeader(78,_8632,_8634,message(_8632,_8634)):-!.
checkMessageHeader(80,_8706,_8708,ping(_8706,_8708)):-!.
checkMessageHeader(_8780,_8782,_8784,_8786):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8870,_8872),_8878):-readStreamLine(_8870,_8878).
readPortMessageBody(ping(_8930,_8932),_8938):-answerPingOnStream(_8930,_8932),!,fail.
prim_sendPort(_9240,_9242,_9244,_9246,_9248):-freeze(_9246,blocked_prim_sendPort(_9240,_9242,_9244,_9246,_9248)).
blocked_prim_sendPort(_9318,_9320,_9322,_9324,_9326):-user:derefAll(_9318,_9332),user:derefRoot(_9320,_9344),prim_sendPortExec(_9332,_9344,_9322,_9324,_9326).
prim_sendPortExec(_9454,'Ports.internalPort'(_9444,0,_9448,_9450),'Prelude.True',_9460,_9462):-!,add2Stream(_9450,_9454),_9460=_9462.
prim_sendPortExec('Ports.SP_Put'(_9556),'Ports.internalPort'(_9560,-1,_9564,_9566),'Prelude.True',_9576,_9578):-!,user:waitUntilGround(_9556,_9576,_9578),writeChars(_9566,_9556),nl(_9566),flush_output(_9566),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9556),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9732),'Ports.internalPort'(_9736,-1,_9740,_9742),'Prelude.True',_9752,_9754):-!,readStreamLine(_9736,_9760),map2M(basics:char_int,_9772,_9760),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9772),nlErr)),user:constrEq(_9772,_9732,_9808,_9752,_9754).
prim_sendPortExec('Ports.SP_GetChar'(_9912),'Ports.internalPort'(_9916,-1,_9920,_9922),'Prelude.True',_9932,_9934):-!,get_code(_9916,_9940),char_int(_9940,_9946),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9946),nlErr)),user:constrEq(_9946,_9912,_9978,_9932,_9934).
prim_sendPortExec('Ports.SP_EOF'(_10082),'Ports.internalPort'(_10086,-1,_10090,_10092),'Prelude.True',_10102,_10104):-!,(atEndOfStream(_10086)->_10112='Prelude.True';_10112='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10112),nlErr)),user:constrEq(_10082,_10112,_10164,_10102,_10104).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10262,-1,_10266,_10268),'Prelude.True',_10278,_10280):-!,close(_10268),close(_10262),_10278=_10280.
prim_sendPortExec(_10392,'Ports.internalPort'(_10382,-1,_10386,_10388),'Prelude.True',_10398,_10400):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10392),nlErr,_10398=_10400.
prim_sendPortExec(_10518,'Ports.internalPort'(_10508,_10510,_10512,_10514),'Prelude.True',_10524,_10526):-string2Atom(_10508,_10532),on_exception(_10566,send2Socket(_10532,_10510,_10512,_10518),(write('ERROR: send to port '),write(_10512),write(@),write(_10532),write(:),nl,(printError(_10566)->true;true))),_10524=_10526.
add2Stream(_10710,_10712):-var(_10710),!,_10710=[_10712|_10722].
add2Stream([],_10788):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10844|_10846],_10852):-add2Stream(_10846,_10852).
prim_ping(_10918,'Ports.internalPort'(_10904,0,_10908,_10910),'Prelude.Just'(0)):-!.
prim_ping(_10990,'Ports.internalPort'(_10976,-1,_10980,_10982),'Prelude.Just'(0)):-!.
prim_ping(_11058,'Ports.internalPort'(_11048,_11050,_11052,_11054),_11062):-string2Atom(_11048,_11068),on_exception(_11090,ping2SocketPort(_11068,_11050,_11052,_11058,_11062),_11062='Prelude.Nothing').
ping2SocketPort(_11154,_11156,_11158,_11160,_11162):-connect2socket(_11154,_11156,_11170,_11172),number_codes(_11158,_11178),putChars(_11172,[80|_11178]),put_code(_11172,10),flush_output(_11172),getElapsedTime(_11204),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11156),writeErr(/),writeErr(_11158),writeErr(@),writeErr(_11154),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11170],_11160,_11292),(_11292=0->readStreamLine(_11170,_11304),closeSocketStream(_11170,_11172),getElapsedTime(_11314),_11324 is _11314-_11204,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11324),writeErr(' ms'),nlErr)),_11162='Prelude.Just'(_11324);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11162='Prelude.Nothing').
prim_connectPortAtSocket(_11566,_11568,_11570,'Ports.internalPort'(_11556,_11558,_11560,'Prelude.()')):-user:derefRoot(_11566,_11558),user:derefRoot(_11568,_11560),user:derefAll(_11570,_11556),!.
send2Socket(_11688,_11690,_11692,_11694):-connect2socket(_11688,_11690,_11702,_11704),number_codes(_11692,_11710),putChars(_11704,[78|_11710]),put_code(_11704,10),show4sending(_11694,_11734,_11736),writeChars(_11704,_11734),put_code(_11704,10),flush_output(_11704),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11690),writeErr(/),writeErr(_11692),writeErr(@),writeErr(_11688),writeErr('": '),writeChars(user_error,_11734),nlErr)),rev(_11736,_11844),receive_extvar_bindings(_11702,_11844).
receive_extvar_bindings(_11972,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_11972).
receive_extvar_bindings(_12050,_12052):-readStreamLine(_12050,_12058),_12058=[86|_12064],number_codes(_12074,_12064),readStreamLine(_12050,_12082),(deleteIndexVariable(_12074,_12052,_12090,_12092)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12092=_12052),(parse_received_message(nostream,nostream,_12082,_12136)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12074),writeErr(': '),putChars(user_error,_12082),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12082),nlErr),!,_12090=_12136,receive_extvar_bindings(_12050,_12092).
show4sending(_12322,_12324,_12326):-numberVars(_12322,_12332,[],_12326),show_term(_12332,qualified,_12324,[]).
getVariableIndex(_12418,[(_12406,_12408)|_12414],_12408):-_12418==_12406,!.
getVariableIndex(_12494,[_12488|_12490],_12498):-getVariableIndex(_12494,_12490,_12498).
getIndexVariable(_12562,[(_12560,_12562)|_12568],_12560):-!.
getIndexVariable(_12636,[_12630|_12632],_12640):-getIndexVariable(_12636,_12632,_12640).
deleteIndexVariable(_12704,[(_12702,_12704)|_12710],_12702,_12710):-!.
deleteIndexVariable(_12794,[_12782|_12784],_12798,[_12782|_12790]):-deleteIndexVariable(_12794,_12784,_12798,_12790).
parse_received_message(_12872,_12874,_12876,_12878):-readTerm(_12876,qualified,_12886,_12888),skipWhiteSpace(_12886,[]),extractVars(_12888,_12878,[],_12904),send_extvar_bindings(_12904,_12910,_12874),closeStreamAfterDones(_12910,_12872,_12874).
send_extvar_bindings([],[],_13010).
send_extvar_bindings([(_13052,_13054)|_13060],[_13064|_13066],_13074):-send_extvar_binding(_13074,_13052,_13054,_13064),send_extvar_bindings(_13060,_13066,_13074).
closeStreamAfterDones([],nostream,_13156):-!.
closeStreamAfterDones([],_13212,_13214):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13212,_13214).
closeStreamAfterDones([_13294|_13296],_13302,_13304):-closeStreamAfterDones(_13294,_13296,_13302,_13304).
closeStreamAfterDones(_13652,_13654,_13656,_13658):-freeze(_13652,blocked_closeStreamAfterDones(_13652,_13654,_13656,_13658)).
blocked_closeStreamAfterDones(_13720,_13722,_13724,_13726):-closeStreamAfterDones(_13722,_13724,_13726).
prim_openProcessPort(_13806,'Ports.internalPort'(_13796,-1,0,_13802)):-user:derefAll(_13806,_13814),string2Atom(_13814,_13826),execCommand(_13826,_13802,_13796,_13836).
prim_choiceSPEP(_14186,_14188,_14190,_14192,_14194):-freeze(_14188,freeze(_14192,blocked_prim_choiceSPEP(_14186,_14188,_14190,_14192,_14194))).
blocked_prim_choiceSPEP(_14270,_14272,_14274,_14276,_14278):-user:derefRoot(_14270,_14284),prim_choiceSPEP_exec(_14284,_14272,_14274,_14276,_14278).
prim_choiceSPEP_exec(_14382,share(_14378),_14386,_14388,_14390):-!,get_mutable(_14394,_14378),(_14394='$eval'(_14400)->_14388=_14390,_14386='Prelude.Right'(_14400);prim_choiceSPEP_exec(_14382,_14394,_14442,_14388,_14390),(_14442='Prelude.Left'(_14450)->_14386=_14442;_14442='Prelude.Right'(_14472),(compileWithSharing(variable)->user:propagateShare(_14472,_14488);_14472=_14488),_14386='Prelude.Right'(_14488),update_mutable('$eval'(_14488),_14378))).
prim_choiceSPEP_exec(_14666,[_14650|_14652],'Prelude.Right'([_14650|_14652]),_14672,_14674):-!,_14672=_14674.
prim_choiceSPEP_exec('Ports.internalPort'(_14756,-1,_14760,_14762),[],_14770,_14772,_14774):-readStreamLine(_14756,_14780),map2M(basics:char_int,_14792,_14780),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14792),nlErr)),_14770='Prelude.Left'(_14792),_14772=_14774,!.
prim_choiceSPEP_exec(_14940,'Ports.basicServerLoop'(_14936),_14944,_14946,_14948):-_14936='Ports.internalPort'(_14952,_14954,_14956,_14958),checkIncomingPortStreams(_14956,_14970,_14972),!,readStreamLine(_14970,_14978),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14936),_14992);_14992='Ports.basicServerLoop'(_14936)),(parse_received_message(_14970,_14972,_14978,_15024)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15024),nlErr)),_14944='Prelude.Right'([_15024|_14992]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_14978),nlErr,prim_choiceSPEP_exec(_14940,_14992,_14944,_14946,_14948)),_14946=_14948,!.
prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_96,_98),'Ports.basicServerLoop'(_102),_110,_112,_114):-_102='Ports.internalPort'(_118,_120,_122,_124),waitForSocketOrInputStreams(_124,_142,_144,_146,[_92],_150),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_102),_164);_164='Ports.basicServerLoop'(_102)),(_142=no->readStreamLine(_92,_198),map2M(basics:char_int,_210,_198),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_210),nlErr)),_110='Prelude.Left'(_210);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_142),nlErr)),(readPortMessage(_122,_144,_146,_306)->(parse_received_message(_144,_146,_306,_316)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_316),nlErr)),_110='Prelude.Right'([_316|_164]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_306),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_386,_98),_164,_110,_112,_114));prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_438,_98),_164,_110,_112,_114))),_112=_114,!.
numberVars(_580,'VAR'(_576),_584,_586):-var(_580),!,(getVariableIndex(_580,_584,_576)->_586=_584;length(_584,_576),_586=[(_580,_576)|_584]).
numberVars(_720,_722,_724,_726):-isShowableArg(_720),_720=..[_734|_736],numberVarsList(_736,_748,_724,_726),_722=..[_734|_748].
numberVarsList([],[],_848,_848).
numberVarsList([_900|_902],[_906|_908],_916,_918):-numberVars(_900,_906,_916,_928),numberVarsList(_902,_908,_928,_918).
extractVars(_1006,_1006,_1010,_1010):-var(_1006),!.
extractVars('VAR'(_1084),_1090,_1092,_1094):-!,(getIndexVariable(_1084,_1092,_1090)->_1094=_1092;_1094=[(_1090,_1084)|_1092]).
extractVars(_1206,_1208,_1210,_1212):-_1206=..[_1216|_1218],extractVarsList(_1218,_1230,_1210,_1212),_1208=..[_1216|_1230].
extractVarsList([],[],_1324,_1324).
extractVarsList([_1376|_1378],[_1382|_1384],_1392,_1394):-extractVars(_1376,_1382,_1392,_1404),extractVarsList(_1378,_1384,_1404,_1394).
prim_after(_1700,_1702,_1704,_1706):-freeze(_1704,blocked_prim_after(_1700,_1702,_1704,_1706)).
blocked_prim_after(_1768,_1770,_1772,_1772):-raise_exception('Ports.after not implemented!').
